###---------------------------------------------------------------------
#	  Name: Hidden2Layer.rb
#   Description: Plugins > Purge...
#   Author: TIG (c) 2008
#   Usage:  Put this file into the Plugins Folder.
#			Pick "Hidden to Layer" off Plugins Menu...
#			Any Hidden/Soft/Smoothed Active Entities are moved to Layer HIDN***
#			This means that any Hidden/S/S Model-based Geometry is moved,  
#			BUT if you want to do Hidden/S/S Entities that are inside of 
#			Groups or Component Definitions then you need to Edit them 
#			so their Entities are then 'Active' and then on running 
#			this tool they will be moved to HIDN...
#     All HIDN edges etc are made 'ordinary' = NO hidden/s/s etc...
#   Version: 1.0	20080314	First issue.
#            1.1  20080314  Also processes soft/smoothed lines,
#                           and all made 'normal' and HIDN 'off'/
###---------------------------------------------------------------------
require 'sketchup.rb'
###---------------------------------------------------------------------
def hidden2layer
  model=Sketchup.active_model
  hidn=model.layers.add("HIDN")### ***change default layer here if desired
  model.start_operation("Hidden to Layer")
  model.active_entities.each{|e|
    if e.hidden?
      e.layer=hidn
      e.hidden=false
    end#if
    if e.typename=="Edge" 
      if e.soft?
        e.layer=hidn
        e.soft=false
      end#if
      if e.smooth?
        e.layer=hidn
        e.smooth=false
       end#if
    end#if
  }
  hidn.visible=false ### set layer to 'off'
  model.commit_operation
end#def
### menu bits
if(not file_loaded?("Hidden2Layer.rb"))
  UI.menu("Plugins").add_item("Hidden to Layer"){hidden2layer}
end
file_loaded("Hidden2Layer.rb")
###